package com.logicbig.example;

import javax.swing.*;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import java.awt.*;

public class TradingProjectTreeRenderer extends DefaultTreeCellRenderer {
    private static final String SPAN_FORMAT = "<span style='color:%s;'>%s</span>";
    private final ImageIcon employeeIcon;

    public TradingProjectTreeRenderer() {
        employeeIcon = new ImageIcon(TradingProjectTreeRenderer.class.getResource("/images/employee.png"));
    }

    @Override
    public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded,
                                                  boolean leaf, int row, boolean hasFocus) {
        super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus);
        DefaultMutableTreeNode node = (DefaultMutableTreeNode) value;
        Object userObject = node.getUserObject();
        if (userObject instanceof ProjectParticipant) {
            ProjectParticipant pp = (ProjectParticipant) userObject;
            String text = String.format(SPAN_FORMAT, "blue", pp.getName());
            text += " [" + String.format(SPAN_FORMAT, "orange", pp.getRole()) + "]";
            this.setText("<html>" + text + "</html>");
            this.setIcon(employeeIcon);
        } else if (userObject instanceof Project) {
            Project project = (Project) userObject;
            String text = String.format(SPAN_FORMAT, "green", project.getName());
            this.setText("<html>" + text + "</html>");
        } else {
            String text = String.format(SPAN_FORMAT, "red", userObject);
            this.setText("<html>" + text + "</html>");
        }
        return this;
    }
}